Module (Gradle API 7.6.4)

Package org.gradle.plugins.ide.idea.model

## Class Module

- java.lang.Object
- - org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject
  - - org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject
    - - org.gradle.plugins.ide.idea.model.Module

- All Implemented Interfaces:
    `org.gradle.plugins.ide.internal.generator.generator.PersistableConfigurationObject`

      public class Module
      extends org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject

  Represents the customizable elements of an iml (via XML hooks everything of the iml is customizable).

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static java.lang.String` | `INHERITED` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Module​(org.gradle.internal.xml.XmlTransformer withXmlActions, PathFactory pathFactory)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected java.lang.Object` | `configure​(Path contentPath, java.util.Set<Path> sourceFolders, java.util.Set<Path> testSourceFolders, java.util.Set<Path> resourceFolders, java.util.Set<Path> testResourceFolders, java.util.Set<Path> generatedSourceFolders, java.util.Set<Path> excludeFolders, java.lang.Boolean inheritOutputDirs, Path outputDir, Path testOutputDir, java.util.Set<Dependency> dependencies, java.lang.String jdkName, java.lang.String languageLevel)` |
    `boolean` | `equals​(java.lang.Object o)` |
    `Path` | `getContentPath()` | The directory for the content root of the module.
    `protected java.lang.String` | `getDefaultResourceName()` |
    `java.util.Set<Dependency>` | `getDependencies()` | The dependencies of this module.
    `java.util.Set<Path>` | `getExcludeFolders()` | The directories to be excluded.
    `java.util.Set<Path>` | `getGeneratedSourceFolders()` | The directories containing generated the production sources.
    `java.lang.String` | `getJdkName()` |
    `Path` | `getOutputDir()` | The output directory for production classes.
    `java.util.Set<Path>` | `getResourceFolders()` | The directories containing resources.
    `java.util.Set<Path>` | `getSourceFolders()` | The directories containing the production sources.
    `Path` | `getTestOutputDir()` | The output directory for test classes.
    `java.util.Set<Path>` | `getTestResourceFolders()` | The directories containing test resources.
    `java.util.Set<Path>` | `getTestSourceFolders()` | The directories containing the test sources.
    `int` | `hashCode()` |
    `protected boolean` | `isDependencyOrderEntry​(java.lang.Object orderEntry)` |
    `boolean` | `isInheritOutputDirs()` | If true, output directories for this module will be located below the output directory for the project; otherwise, `outputDir` and `testOutputDir` will take effect.
    `protected void` | `load​(Node xml)` |
    `void` | `setContentPath​(Path contentPath)` |
    `void` | `setDependencies​(java.util.Set<Dependency> dependencies)` |
    `void` | `setExcludeFolders​(java.util.Set<Path> excludeFolders)` |
    `void` | `setGeneratedSourceFolders​(java.util.Set<Path> generatedSourceFolders)` |
    `void` | `setInheritOutputDirs​(boolean inheritOutputDirs)` |
    `void` | `setJdkName​(java.lang.String jdkName)` |
    `void` | `setOutputDir​(Path outputDir)` |
    `void` | `setResourceFolders​(java.util.Set<Path> resourceFolders)` | Sets the directories containing resources.
    `void` | `setSourceFolders​(java.util.Set<Path> sourceFolders)` |
    `void` | `setTestOutputDir​(Path testOutputDir)` |
    `void` | `setTestResourceFolders​(java.util.Set<Path> testResourceFolders)` | Sets the directories containing test resources.
    `void` | `setTestSourceFolders​(java.util.Set<Path> testSourceFolders)` |
    `protected void` | `store​(Node xml)` |
    `java.lang.String` | `toString()` |

    - ### Methods inherited from class org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject

      `findFirstChildNamed, findFirstChildWithAttributeValue, findFirstWithAttributeValue, findOrCreateFirstChildNamed, findOrCreateFirstChildWithAttributeValue, getChildren, getXml, load, store, transformAction, transformAction`

    - ### Methods inherited from class org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject

      `load, loadDefaults, store`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### INHERITED

          public static final java.lang.String INHERITED

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### Module

          public Module​(org.gradle.internal.xml.XmlTransformer withXmlActions,
                        PathFactory pathFactory)

  - ### Method Detail

    - #### getContentPath

          public Path getContentPath()

      The directory for the content root of the module. Defaults to the project directory. If null, the directory containing the output file will be used.

    - #### setContentPath

          public void setContentPath​(Path contentPath)

    - #### getSourceFolders

          public java.util.Set<Path> getSourceFolders()

      The directories containing the production sources. Must not be null.

    - #### setSourceFolders

          public void setSourceFolders​(java.util.Set<Path> sourceFolders)

    - #### getTestSourceFolders

          public java.util.Set<Path> getTestSourceFolders()

      The directories containing the test sources. Must not be null.

    - #### setTestSourceFolders

          public void setTestSourceFolders​(java.util.Set<Path> testSourceFolders)

    - #### getResourceFolders

          public java.util.Set<Path> getResourceFolders()

      The directories containing resources. Must not be null.
      Since:
        4.7

    - #### setResourceFolders

          public void setResourceFolders​(java.util.Set<Path> resourceFolders)

      Sets the directories containing resources.
      Since:
        4.7

    - #### getTestResourceFolders

          public java.util.Set<Path> getTestResourceFolders()

      The directories containing test resources. Must not be null.
      Since:
        4.7

    - #### setTestResourceFolders

          public void setTestResourceFolders​(java.util.Set<Path> testResourceFolders)

      Sets the directories containing test resources.
      Since:
        4.7

    - #### getGeneratedSourceFolders

          public java.util.Set<Path> getGeneratedSourceFolders()

      The directories containing generated the production sources. Must not be null.

    - #### setGeneratedSourceFolders

          public void setGeneratedSourceFolders​(java.util.Set<Path> generatedSourceFolders)

    - #### getExcludeFolders

          public java.util.Set<Path> getExcludeFolders()

      The directories to be excluded. Must not be null.

    - #### setExcludeFolders

          public void setExcludeFolders​(java.util.Set<Path> excludeFolders)

    - #### isInheritOutputDirs

          public boolean isInheritOutputDirs()

      If true, output directories for this module will be located below the output directory for the project; otherwise, `outputDir` and `testOutputDir` will take effect.

    - #### setInheritOutputDirs

          public void setInheritOutputDirs​(boolean inheritOutputDirs)

    - #### getOutputDir

          public Path getOutputDir()

      The output directory for production classes. If `null`, no entry will be created.

    - #### setOutputDir

          public void setOutputDir​(Path outputDir)

    - #### getTestOutputDir

          public Path getTestOutputDir()

      The output directory for test classes. If `null`, no entry will be created.

    - #### setTestOutputDir

          public void setTestOutputDir​(Path testOutputDir)

    - #### getDependencies

          public java.util.Set<Dependency> getDependencies()

      The dependencies of this module. Must not be null.

    - #### setDependencies

          public void setDependencies​(java.util.Set<Dependency> dependencies)

    - #### getJdkName

          public java.lang.String getJdkName()

    - #### setJdkName

          public void setJdkName​(java.lang.String jdkName)

    - #### getDefaultResourceName

          protected java.lang.String getDefaultResourceName()

      Specified by:
        `getDefaultResourceName` in class `org.gradle.plugins.ide.internal.generator.AbstractPersistableConfigurationObject`

    - #### configure

          protected java.lang.Object configure​(Path contentPath,
                                               java.util.Set<Path> sourceFolders,
                                               java.util.Set<Path> testSourceFolders,
                                               java.util.Set<Path> resourceFolders,
                                               java.util.Set<Path> testResourceFolders,
                                               java.util.Set<Path> generatedSourceFolders,
                                               java.util.Set<Path> excludeFolders,
                                               java.lang.Boolean inheritOutputDirs,
                                               Path outputDir,
                                               Path testOutputDir,
                                               java.util.Set<Dependency> dependencies,
                                               java.lang.String jdkName,
                                               java.lang.String languageLevel)

    - #### load

          protected void load​(Node xml)

      Overrides:
        `load` in class `org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject`

    - #### store

          protected void store​(Node xml)

      Overrides:
        `store` in class `org.gradle.plugins.ide.internal.generator.XmlPersistableConfigurationObject`

    - #### isDependencyOrderEntry

          protected boolean isDependencyOrderEntry​(java.lang.Object orderEntry)

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### equals

          public boolean equals​(java.lang.Object o)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`